#include <jabberd.h>
#include "yahoolib.h"

typedef struct yahootrans_instance_st
{
    ppdb PPDB;
    ppdb y_ppdb;
    instance  i;
    xht s;
    xdbcache  xc;
    mtq       q;
    xmlnode   c;
    char*     start_time;
} _yahootrans_instance, *yahootrans_instance;

typedef struct yahootrans_jpacket_st
{
    jpacket jp;
    yahootrans_instance yti;
} _yahootrans_jpacket, *yahootrans_jpacket;

#define YAHOO_TRANS_VERSION "1.4pre2"
#define YAHOO_NS "yahootrans:data"

/* sessions.c */
typedef enum { YAHOO_STATE_ONLINE, YAHOO_STATE_ERROR } yahoo_session_state;
typedef struct yahoo_sessions_struct
{
    pool p;
    yahootrans_instance yti;
    yahoo_session_state state;
    mtq q;
    jid user;
    jid id;
    mio m;
    struct yahoo_context *Con;
    int status;
    char *yahoo_host;
    jid online_users;
} _yahoo_session, *yahoo_session;

extern struct yahoo_options Opts;
void yahoo_session_end(yahoo_session s);
mio yahoo_session_create(yahootrans_instance yti, char *user, char *pword, jpacket jp);

/* presence.c */
int yahoo_subscribe_user(yahootrans_jpacket yjp);
int yahoo_unsubscribe_user(yahootrans_jpacket yjp);
void yahoo_update_status(yahootrans_instance yti, yahoo_session s,xmlnode x);
int yahoo_parse_presence(yahootrans_jpacket yjp);

void yahoo_send_presence(yahoo_session s,jpacket jp,char *from,char *type,char *status,char *show);

/* util.c */
char *str_to_UTF8(pool p,unsigned char *in);
unsigned char *UTF8_to_str(pool p,unsigned char *in);
int yahoo_xdb_set(yahootrans_instance yti, char *host, jid owner, xmlnode data);
xmlnode yahoo_xdb_get(yahootrans_instance yti, char *host, jid owner);
yahoo_session yahoo_find_session(yahootrans_instance yti, jid j);


/* parser.c */
void yahoo_parse_jpacket(void *arg);

/* message.c */
int yahoo_parse_message(yahootrans_jpacket yjp);
void yahoo_send_message(yahoo_session s,jpacket jp,char *from,char *type,char *body,char *subject);
void yahoo_send_error(yahootrans_instance yti, jid j,char *code,char *errmsg);
