
#include <yahootrans.h>

/* parse an incoming jabber message */
int yahoo_parse_message(yahootrans_jpacket yjp)
{
    jpacket jp = yjp->jp;
    char *body;
    yahoo_session s;
    xmlnode tmpx;
            
    s = yahoo_find_session(yjp->yti, jp->from);

    if(s == NULL)
    {
        yahoo_send_error(yjp->yti, jp->from, "407", "Yahoo! Server doesn't think you are connected.");
    }
    else if(jp->to->user == NULL) 
    {  /* possible place for admin mod_announce type thing? */
        yahoo_send_error(yjp->yti, jp->from,"406", "Message sent to yahoo with no user.");
    }
    else
    {
        tmpx = xmlnode_get_tag(jp->x, "body");
        if(tmpx == NULL) 
        {
            xmlnode_free(jp->x);
            return 1;
        }

        body = UTF8_to_str(jp->p, xmlnode_get_data(tmpx));
        if(body != NULL && s->Con != NULL && s->Con->login_id != NULL) 
            yahoo_cmd_msg_offline(s->Con, s->Con->login_id, jp->to->user, body);
        else
            yahoo_send_error(yjp->yti, jp->from, "406", "failed to send message");    
    }

    xmlnode_free(jp->x);
    return 0;
}

/* Sends a jabber user a message */
void yahoo_send_message(yahoo_session s, jpacket jp, char *from, char *type, char *body, char *subject)
{
    xmlnode message;

    if(s == NULL || from == NULL || body == NULL) 
        return;

    message = xmlnode_new_tag("message");

    if(type != NULL)
        xmlnode_put_attrib(message, "type", type);

    if(subject != NULL)
        xmlnode_insert_cdata(xmlnode_insert_tag(message, "subject"),subject, -1);

    xmlnode_put_attrib(message, "from", from);
    xmlnode_put_attrib(message, "to", jid_full(s->user));

    xmlnode_insert_cdata(xmlnode_insert_tag(message, "body") ,body, -1);

    deliver(dpacket_new(message), s->yti->i);

    /* cleanup the jpacket jp, if it's attached... */
    if(jp != NULL) 
        xmlnode_free(jp->x);
}

/* build and send a jabber error */
void yahoo_send_error(yahootrans_instance yti, jid j, char *code, char *errmsg)
{
    xmlnode err, error;
    if(j == NULL || code == NULL || errmsg == NULL) 
        return;
    
    err = xmlnode_new_tag("message");

    xmlnode_put_attrib(err,"to", jid_full(j));
    xmlnode_put_attrib(err,"from", yti->i->id);
    xmlnode_put_attrib(err, "type", "error");

    error=xmlnode_insert_tag(err, "error");
    xmlnode_put_attrib(error, "code", code);
    xmlnode_insert_cdata(error, errmsg, -1);

    deliver(dpacket_new(err), yti->i);
}
