#include <yahootrans.h>

char *str_to_UTF8(pool p,unsigned char *in)
{
    int n,i=0;
    char *result = NULL;
    /* for now, allocate more than enough space... */
    if(in==NULL) return NULL;
    result = (char*)pmalloco(p,strlen(in)*2+1);
    for(n=0;n<strlen(in);n++)
    {
        char *font;
        long c=(long)in[n];
        /*check for <font ....> html codes*/
        font=strstr(&in[n],"<font ");
        if(strlen(&in[n])>7&&strncasecmp(&in[n],"<font ",6)==0)
        {
            font=strchr(font,'>');
            if(font!=NULL)
            {
                n=((long)font)-((long)in);
                continue;
            }
        }
        /*strip out color codes*/
        if(c==27)
        {  
            n+=2;
            if(in[n]=='x')
                n++;
            if(in[n]=='3')
                n++;
            n++;
            continue;
        }
        if(c==0x0D||c==0x0a)
            continue;
        if(c<128)
        {
            result[i++]=(char)c;
        }
        else
        {
            result[i++]=(char)((c>>6)|192);
            result[i++]=(char)((c&63)|128);
        }
    }
    result[i]='\0';
    return result;
}

unsigned char *UTF8_to_str(pool p,unsigned char *in)
{
    int n,i;
    unsigned char *result = NULL;
    if(in==NULL) return NULL;
    result=(unsigned char*)pmalloco(p,strlen(in));
    n = 0;
    i = 0;
    while(n<=strlen(in)-1)
    {
       long c=(long)in[n];
       if(c<0x80)
           result[i++]=(char)c;
       else
       {
           if((c&0xC0)==0xC0)
               result[i++]=(char)(((c&0x03)<<6)|(((long)in[++n])&0x3F));
           else if((c&0xE0)==0xE0)
               result[i++]=(char)(((c&0xF)<<4)|(((long)in[++n])&0x3F)|(((long)in[++n])&0x3F)); 
           else if((c&0xF0)==0xF0)
               n+=3;
           else if((c&0xF8)==0xF8)
               n+=4;
           else if((c&0xFC)==0xFC)
               n+=5;
        }
        n++;
    }
        result[i]='\0';
        return result;
}


int yahoo_xdb_set(yahootrans_instance yti, char *host, jid owner, xmlnode data)
{
    int ret;
    jid j;
    char *res;

    res = owner->resource;
    jid_set(owner, NULL, JID_RESOURCE);

    j = jid_new(owner->p, spools(owner->p, shahash(jid_full(owner)), "@", host, owner->p));
    ret = xdb_act(yti->xc, j, YAHOO_NS, "insert", "logon", data);
    xmlnode_free(data);

    jid_set(owner, res, JID_RESOURCE);

    return ret;
}

xmlnode yahoo_xdb_get(yahootrans_instance yti, char *host, jid owner)
{
    xmlnode x;
    jid j;
    char *res;

    res = owner->resource;
    jid_set(owner, NULL, JID_RESOURCE);

    j = jid_new(owner->p, spools(owner->p, shahash(jid_full(owner)), "@", host, owner->p));
    x= xdb_get(yti->xc, j, YAHOO_NS);

    jid_set(owner, res, JID_RESOURCE);

    return xmlnode_get_firstchild(x);
}

yahoo_session yahoo_find_session(yahootrans_instance yti, jid j)
{
    yahoo_session s;
    jid new;

    new = jid_new(j->p, jid_full(j));
    jid_set(new, NULL, JID_RESOURCE);

    s = xhash_get(yti->s, jid_full(new));

    return s;
}
